#include "ItemTypeNameFactory.h"

const Framework::Text ItemTypeNameFactory::TYPE_ID = "ItemTypeName";

ItemTypeNameFactory::ItemTypeNameFactory()
    : SimpleTypeFactory<Framework::Text*>(),
      itemTypeNames(0)
{}

ItemTypeNameFactory::~ItemTypeNameFactory()
{
    if (itemTypeNames)
    {
        itemTypeNames->release();
    }
}

void ItemTypeNameFactory::setItemTypeNames(
    Framework::RCArray<Framework::Text>* itemTypeNames)
{
    this->itemTypeNames = itemTypeNames;
}

Framework::Text* ItemTypeNameFactory::fromJson(
    Framework::JSON::JSONValue* zJson) const
{
    return new Framework::Text(zJson->asString()->getString());
}

Framework::JSON::JSONValue* ItemTypeNameFactory::toJson(
    Framework::Text* value) const
{
    return new Framework::JSON::JSONString(value->getText());
}

Framework::Validator::DataValidator* ItemTypeNameFactory::getValidator() const
{
    if (!itemTypeNames)
    {
        return Framework::Validator::DataValidator::buildForString()
            ->finishString();
    }
    else
    {
        return Framework::Validator::DataValidator::buildForString()
            ->whichIsOneOf(*itemTypeNames)
            ->finishString();
    }
}